# python -m pip install selenium
from selenium import webdriver
from selenium.webdriver.chrome.options import Options
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC
from itertools import *
import warnings

def entry(argv):
    opts = Options()
    
    # Requires current version of Chrome/Chromium (i.e. Chrome Beta)
    opts.binary_location = "path to chrome executable goes here"
    
    # Download https://chromedriver.storage.googleapis.com/index.html?path=99.0.4844.17/ and put the correct path to the executable here.
    with warnings.catch_warnings():
        warnings.simplefilter("ignore")
        driver = webdriver.Chrome(options = opts, executable_path = "path to chromedriver executable goes here")
    # Change the above to webdriver.Firefox('path/to/geckodriver') if that is easier.
    
    nums = list(argv[::-2])
    i = 0
    output = nums[0] + " "
    del nums[0]
    r = ""
    for key,ops in reversed([(key,"".join(group)) for key,group in groupby(argv[1::2],lambda op:op in "*/")]):
        head, nums = nums[:len(ops)], nums[len(ops):]
        output += " ".join(head) + " "
        if key:
            output += ops
        else:
            r += ops[::-1]
    
    wait = WebDriverWait(driver, 2)
    driver.get("https://staxlang.xyz/#c=" + (output + " ".join(nums) + r[::-1]).translate({47:"s%2F",45:"s-",43:"%2B",32:"+"}))
    wait.until(lambda driv: driv.execute_script("return document.readyState") == "complete")
    driver.find_element(By.XPATH, "//body").send_keys(Keys.F8)
    wait.until(EC.visibility_of_element_located((By.ID, "output")))
    return int(driver.find_element(By.ID, "output").get_attribute('innerText'))

if __name__=="__main__":
    print(entry("1+2*3/4-5*6-7+8/9"))

